import './style.css';
import { defineComponent as $, ref as N, computed as f, resolveComponent as O, openBlock as d, createElementBlock as h, createElementVNode as v, withModifiers as C, normalizeClass as k, createTextVNode as V, toDisplayString as p, Fragment as q, renderList as K, withDirectives as B, createBlock as D, vShow as A, createCommentVNode as x, withKeys as w, normalizeStyle as E } from "vue";
const J = { class: "json-view-item" }, z = { key: 0 }, F = ["onClick", "aria-expanded"], L = { class: "properties" }, M = ["role", "tabindex"], T = { class: "value-key" }, _ = $({
  name: "json-view-item"
}), G = /* @__PURE__ */ Object.assign(_, {
  props: {
    data: {
      required: !0,
      type: Object
    },
    maxDepth: {
      type: Number,
      required: !1,
      default: 1
    },
    canSelect: {
      type: Boolean,
      required: !1,
      default: !1
    }
  },
  emits: ["selected"],
  setup(t, { emit: m }) {
    const a = t, o = N(a.data.depth < a.maxDepth), g = () => {
      o.value = !o.value;
    }, u = (e) => {
      m("selected", {
        key: e.key,
        value: e.value,
        path: e.path
      });
    }, b = (e) => {
      m("selected", e);
    }, S = (e) => isNaN(e.key) ? '"' + e.key + '":' : e.key + ":", n = (e) => {
      switch (typeof e) {
        case "string":
          return { color: "var(--vjc-string-color)" };
        case "number":
          return { color: "var(--vjc-number-color)" };
        case "boolean":
          return { color: "var(--vjc-boolean-color)" };
        case "object":
          return { color: "var(--vjc-null-color)" };
        case "undefined":
          return { color: "var(--vjc-null-color)" };
        default:
          return { color: "var(--vjc-valueKey-color)" };
      }
    }, c = f(() => ({
      "chevron-arrow": !0,
      opened: o.value
    })), s = f(() => ({
      "value-key": !0,
      "can-select": a.canSelect
    })), l = f(() => a.data.type === "array" ? a.data.length === 1 ? a.data.length + " element" : a.data.length + " elements" : a.data.length === 1 ? a.data.length + " property" : a.data.length + " properties"), i = f(() => typeof a.data.value > "u" ? "undefined" : JSON.stringify(a.data.value));
    return (e, r) => {
      const j = O("json-view-item");
      return d(), h("div", J, [
        t.data.type === "object" || t.data.type === "array" ? (d(), h("div", z, [
          v("button", {
            onClick: C(g, ["stop"]),
            class: "data-key",
            "aria-expanded": o.value ? "true" : "false"
          }, [
            v("div", {
              class: k(c.value)
            }, null, 2),
            V(" " + p(t.data.key) + ": ", 1),
            v("span", L, p(l.value), 1)
          ], 8, F),
          (d(!0), h(q, null, K(t.data.children, (y) => B((d(), D(j, {
            onSelected: b,
            key: S(y),
            data: y,
            maxDepth: t.maxDepth,
            canSelect: t.canSelect
          }, null, 8, ["data", "maxDepth", "canSelect"])), [
            [A, o.value]
          ])), 128))
        ])) : x("", !0),
        t.data.type === "value" ? (d(), h("div", {
          key: 1,
          class: k(s.value),
          onClick: r[0] || (r[0] = (y) => u(t.data)),
          onKeyup: [
            r[1] || (r[1] = w((y) => u(t.data), ["enter"])),
            r[2] || (r[2] = w((y) => u(t.data), ["space"]))
          ],
          role: t.canSelect ? "button" : void 0,
          tabindex: t.canSelect ? "0" : void 0
        }, [
          v("span", T, p(t.data.key) + ":", 1),
          v("span", {
            style: E(n(t.data.value))
          }, p(i.value), 5)
        ], 42, M)) : x("", !0)
      ]);
    };
  }
});
const H = $({
  name: "json-view"
}), I = /* @__PURE__ */ Object.assign(H, {
  props: {
    data: {
      required: !0
    },
    rootKey: {
      type: String,
      required: !1,
      default: "root"
    },
    maxDepth: {
      type: Number,
      required: !1,
      default: 1
    },
    colorScheme: {
      type: String,
      required: !1,
      default: "light"
    }
  },
  emits: ["selected"],
  setup(t, { emit: m }) {
    const a = t, o = (n, c, s, l, i) => {
      if (g(c)) {
        let e = [];
        for (let [r, j] of Object.entries(c))
          e.push(
            o(
              r,
              j,
              s + 1,
              i ? `${l}${n}.` : `${l}`,
              !0
            )
          );
        return {
          key: n,
          type: "object",
          depth: s,
          path: l,
          length: e.length,
          children: e
        };
      } else if (u(c)) {
        let e = [];
        for (let r = 0; r < c.length; r++)
          e.push(
            o(
              r.toString(),
              c[r],
              s + 1,
              i ? `${l}${n}[${r}].` : `${l}`,
              !1
            )
          );
        return {
          key: n,
          type: "array",
          depth: s,
          path: l,
          length: e.length,
          children: e
        };
      } else
        return {
          key: n,
          type: "value",
          path: i ? l + n : l.slice(0, -1),
          depth: s,
          value: c
        };
    }, g = (n) => typeof n == "object" && n !== null && !u(n), u = (n) => Array.isArray(n), b = (n) => {
      m("selected", n);
    }, S = f(() => typeof a.data == "object" ? o(a.rootKey, { ...a.data }, 0, "", !0) : {
      key: a.rootKey,
      type: "value",
      path: "",
      depth: 0,
      value: a.data
    });
    return (n, c) => (d(), D(G, {
      class: k([{ "root-item": !0, dark: t.colorScheme === "dark" }]),
      data: S.value,
      maxDepth: t.maxDepth,
      onSelected: b
    }, null, 8, ["class", "data", "maxDepth"]));
  }
}), Q = { JSONView: I };
export {
  Q as default
};
